<?php
/**
 * Created by PhpStorm.
 * User: felipesantos
 * Date: 02/09/2016
 * Time: 11:14
 */

namespace HCM\FPA\Services;

use Doctrine\ORM\EntityManager;
use Folha\Entities\FpaItemlotelanc;
use Folha\Entities\FpaTipomoviment;
use Folha\Entities\FpaLotelancevento;
use HCM\Util\DateUtil;
use Geral\Util\NovoCodigo;
use HCM\Util\HCMParameters;
use HCM\Util\Valor;
use HCM\Util\Messages;
use HCM\Util\Repositories;
use HCM\FPA\Entity\FpacalculofolhaEntity;
use HCM\FPA\Services\ItensCalculoService;
use Teknisa\Model\Gestaopessoas\Entities\FpaCalculofolha;
use Teknisa\Model\Gestaopessoas\Entities\GpeVinculom;
use Teknisa\Model\Gestaopessoas\Entities\GpeVinculoh;
use Teknisa\Model\Gestaopessoas\Entities\FpaEventoh;
use Teknisa\Model\Gestaopessoas\Entities\FpaItecalcfolha;
use Zeedhi\Framework\DTO\Response\Message;

class LancamentoEventoService{
    
    protected $entityManager;
    protected $hcmParameters;
    protected $lancamentoEventoRepository;
    protected $itemLoteLancRepository;
    protected $calculoFolha;
    protected $itemCalcFolha;
    
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters, \HCM\FPA\Repository\LancamentoEventoRepository $lancamentoEventoRepository, \HCM\FPA\Repository\ItemLoteLancRepository $itemLoteLancRepository, ItensCalculoService $itensCalculoService) {
        $this->entityManager = $entityManager;
        $hcmParameters->setParamsOperador();
        $this->hcmParameters = $hcmParameters;
        $this->lancamentoEventoRepository = $lancamentoEventoRepository;
        $this->itemLoteLancRepository = $itemLoteLancRepository;
        $this->itensCalculoService = $itensCalculoService;
        $this->calculoFolha = new FpacalculofolhaEntity($entityManager, $hcmParameters);
        $this->itemCalcFolha = Repositories::FPA_ITECALCFOLHA;
    }
    
    
    public function getEventoPorVinculo($vinculos, $eventos, $nrorg, $dtCompetencia, $movimento, $vrrefolha, $vreventofolha, $idrefevalorcalc, $dtocorrencia, $qtocorproxperi ){
        
        // variaveis
        $dados = array();
        $nrModalidadeCalc = $this->hcmParameters->getNrModalidadeCalculo();
        $nrOcorrenciaCalc = $this->hcmParameters->getNrOcorrenciaCalculo();
        $nrorg_padrao = $this->hcmParameters->getNrorgPadrao();  
        $tipoMovimento = $this->entityManager->getRepository(Repositories::FPA_TIPOMOVIMENT)->findOneBy(array('nrorg' => $nrorg, 'nrorg' => $nrorg_padrao, 'nrtipomoviment' => $movimento));
        
        foreach ($vinculos as $vinculo) {
            
            $estrutgeren = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->findOneBy(array('nrorg' => $nrorg, 'nrestruturam' => $vinculo->historico->getNrestrutgeren()));
            $estrutlegal = $this->entityManager->getRepository(Repositories::ESTRUTURAM)->findOneBy(array('nrorg' => $nrorg, 'nrestruturam' => $vinculo->historico->getNrestrutlegal()));
       
            foreach ($eventos as $nreventom) {
            // Verifica se ja existe
                $calculoFolha = $this->calculoFolha->retornaCalculoFolha($nrorg, $movimento, DateUtil::getDataDeString($dtCompetencia, DateUtil::FORMATO_BRASILEIRO, true), $nrModalidadeCalc, $nrOcorrenciaCalc);
                $retorno = $this->lancamentoEventoRepository->getDadosEvento($vinculo->getNrvinculom(), $nreventom, $nrorg, $dtCompetencia, $calculoFolha[0]->getNrcalculofolha(), $nrorg_padrao);
                // caso não exista:
                if(sizeof($retorno) === 0){
                    $idEventoDemonst = $this->itemLoteLancRepository->getIdeventodemonst($nrorg_padrao, $nreventom, $dtCompetencia, $nrorg);
                    $eventoh = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento($nreventom, $nrorg, $nrorg_padrao, $dtCompetencia);
                    $naturezaRubrica = $this->entityManager->getRepository(Repositories::NATUREZARUBRICA)->findOneBy(array("nrnaturubr" => $eventoh->historico->getNrnaturubr(), 'nrorg' => $nrorg, 'nrorg' => $nrorg_padrao));
                    // objeto de item
                    $obj = array(
                            'NRCALCULOFOLHA'   => $calculoFolha[0]->getNrcalculofolha(),
                            'NRVINCULOM'       => $vinculo->getNrvinculom(),
                            'NMVINCULOM'       => $vinculo->getNmvinculom(),
                            'NREVENTOM'        => $nreventom,
                            'NMEVENTOH'        => $eventoh->historico->getNmeventoh(),
                            'IDTIPOEVENTO'     => $eventoh->getIdtipoevento(),
                            'NRORG'            => $nrorg,
                            'IDEVENDEMONCALC'  => $idEventoDemonst[0]['IDEVENTODEMONST'],
                            'IDREFEVALORCALC'  => $idrefevalorcalc,
                            'VRREFFOLHA'       => $vrrefolha,
                            'VREVENTOFOLHA'    => $vreventofolha,
                            'QTOCORPROXPERI'   => $qtocorproxperi, 
                            'VRVELHO'          => NULL,
                            'DTOCORRENCIA'     => $dtocorrencia,
                            'NRESTRUTLEGAL'    => $vinculo->historico->getNrestrutlegal(),
                            'NMESTRUTLEGAL'    => $estrutlegal->getNmestruturam(),
                            'NRESTRUTGEREN'    => $vinculo->historico->getNrestrutgeren(),
                            'NMESTRUTGEREN'    => $estrutgeren->getNmestruturam(),
                            'NRLOTELANCEVENTO' => NULL,
                            'DSITEMCALCFOLHA'  => NULL,
                            'QTOCORPROXPERI'   => 1,
                            'DTGERULTCNAB'     => NULL,
                            'NRTIPOMOVIMENT'   => $movimento,
                            'NMTIPOMOVIMENT'   => $tipoMovimento->getNmtipomoviment(),
                            'DTINCLUSAO'       => null,
                            'NRORGINCLUSAO'    => null,
                            'CDOPERINCLUSAO'   => null,
                            'DTULTATU'         => null,
                            'NRORGULTATU'      => null,
                            'CDOPERULTATU'     => null,
                            'CDESOCIAL'        => !empty($naturezaRubrica) ? $naturezaRubrica->getCdesocial() : null
                            );  
                            
                    $dados[] = $obj;
                }else{
                    $evento = array();
                    foreach($retorno as $item){
                        $item['NRTIPOMOVIMENT'] = $movimento;
                        $item['NMTIPOMOVIMENT'] = $tipoMovimento->getNmtipomoviment();
                        if($item['VREVENTOFOLHA'] === 0){
                            $item['VREVENTOFOLHA'] = $vreventofolha;
                        }
                        if($item['VRREFFOLHA'] === 0){
                            $item['VRREFFOLHA'] = $vrrefolha;
                        }
                        $eventoh = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento($nreventom, $nrorg, $nrorg_padrao, $dtCompetencia);
                        $naturezaRubrica = $this->entityManager->getRepository(Repositories::NATUREZARUBRICA)->findOneBy(array("nrnaturubr" => $eventoh->historico->getNrnaturubr(), 'nrorg' => $nrorg, 'nrorg' => $nrorg_padrao));
                        $item['CDESOCIAL'] = !empty($naturezaRubrica) ? $naturezaRubrica->getCdesocial() : null;
                        $dados[] = $item;
                    }
                    
                }
            }
        }             
        return $dados;
    }
    
    public function deleteItemCalculoFolha($rows){
        try{
            $this->entityManager->beginTransaction();
            foreach ($rows as $row) {
                if(array_key_exists('NRITEMCALCFOLHA', $row)){
                $itemCalcFolha = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findOneBy(array('nritemcalcfolha' => $row['NRITEMCALCFOLHA'], 'nrorg' => $row['NRORG']));
                    $this->entityManager->remove($itemCalcFolha);
                    $this->entityManager->flush($itemCalcFolha);
                    
                }
            }
            $this->entityManager->commit(); 
        }catch(\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    public function setItemCalculoFolha($rows, &$response){
        try{
            $this->entityManager->beginTransaction();
            foreach($rows as $row){
                // verifica se a alteração inline é válida
                if($row['VREVENTOFOLHA'] or $row['VRREFFOLHA']){
                    
                    $dtCompetencia = $this->hcmParameters->getDtCompetencia();
                    $nrorg_padrao = $this->hcmParameters->getNrorgPadrao();
                    $row['VREVENTOFOLHA'] = (float)($row['VREVENTOFOLHA']);
                    
                    
                    // Somente para o vale transporte é permitido fazer alterações mesmo que já exista líquido.
                    if ($row['NRTIPOMOVIMENT'] != FpaTipomoviment::TP_MOV_VALE_TRANSPORTE && $row['IDEVENDEMONCALC'] != 'S') {
                        $liquido = $this->itensCalculoService->validaLiquido($row['NRTIPOMOVIMENT'], $row['NRCALCULOFOLHA'], $row['NRVINCULOM'], $this->hcmParameters->getDtCompetencia(), $row['NRORG']);
                        if ($liquido) {
                            $response->addMessage(new Message(Messages::HCM01000_FPA_BLOQ_OPER_VINC_LIQ_ERROR, Message::TYPE_ERROR));
                            return;
                        }
                    }
                
                    $idevendemoncalc;
                    $result = $this->lancamentoEventoRepository->getDadosEvento($row['NRVINCULOM'], $row['NREVENTOM'], $row['NRORG'], $row['DTOCORRENCIA'], $row['NRCALCULOFOLHA'], $this->hcmParameters->getNrorgPadrao());
                    
                    if(!empty($result)){
                        $obj = $this->entityManager->getRepository(Repositories::FPA_ITECALCFOLHA)->findOneBy(array('nrorg' => $row['NRORG'], 'nritemcalcfolha' => $result[0]['NRITEMCALCFOLHA']));
                        $idevendemoncalc = $obj->getIdevendemoncalc();
                    }else{
                        $obj = new $this->itemCalcFolha();
                        $obj->setNritemcalcfolha(\HCM\Util\NovoCodigo::geraCodigo($row['NRORG'], 'FPA_ITECALCFOLHA', 1, 12, true));
                        $eventoh = $this->entityManager->getRepository(Repositories::FPA_EVENTOM)->retornaEvento($row['NREVENTOM'], $row['NRORG'], $nrorg_padrao, $dtCompetencia);
                        $idevendemoncalc = $eventoh->historico->getideventodemonst();
                    }
                    
                    if($row['DTOCORRENCIA'] === null){
                        $row['DTOCORRENCIA'] = $this->hcmParameters->getDtCompetencia();   
                    }
                    
                    $row['VREVENTOFOLHA'] = array_key_exists('VREVENTOFOLHA', $row) ? $row['VREVENTOFOLHA'] : $row['VREVENTOFOLHA'];
                    $row['VRREFFOLHA'] = array_key_exists('VRREFFOLHA', $row) ? $row['VRREFFOLHA'] : $row['VRREFFOLHA'];
                    
                    if(!empty($row['VREVENTOFOLHA']) && !is_float($row['VREVENTOFOLHA'])){
                        $row['VREVENTOFOLHA'] = str_replace('.', '', $row['VREVENTOFOLHA']);
                        $row['VREVENTOFOLHA'] = str_replace(',', '.', $row['VREVENTOFOLHA']);
                        $row['VREVENTOFOLHA'] = floatval($row['VREVENTOFOLHA']);
                    }
                    
                    if(!empty($row['VRREFFOLHA']) && !is_float($row['VRREFFOLHA'])){
                        $row['VRREFFOLHA'] = str_replace('.', '', $row['VRREFFOLHA']);
                        $row['VRREFFOLHA'] = str_replace(',', '.', $row['VRREFFOLHA']);
                        $row['VRREFFOLHA'] = floatval($row['VRREFFOLHA']);
                    }
                    
                    
                    //FORÇAR VALOR
                    $idRefeValorCalc = $row['IDREFEVALORCALC'];
                    if(!$row['IDREFEVALORCALC'] || $row['IDREFEVALORCALC'] == 'NORMAL' 
                        || $row['IDREFEVALORCALC'] == 'VALOR'|| $row['IDREFEVALORCALC'] == 'REFERENCIA'){
                        if((array_key_exists('changed_VRREFFOLHA', $row) && array_key_exists('changed_VREVENTOFOLHA', $row)) || 
                            (array_key_exists('changed_VREVENTOFOLHA', $row)  && $row['IDREFEVALORCALC'] == 'REFERENCIA') ||
                            (array_key_exists('changed_VRREFFOLHA', $row) && $row['IDREFEVALORCALC'] == 'VALOR')){
                            $idRefeValorCalc = 'REFERENCIA_VALOR';
                        }else if(array_key_exists('changed_VREVENTOFOLHA', $row)){
                            $idRefeValorCalc = 'VALOR';
                        }else if(array_key_exists('changed_VRREFFOLHA', $row)){
                            $idRefeValorCalc = 'REFERENCIA';
                        }else {
                            $idRefeValorCalc = 'NORMAL';
                        }
                    }
                    
                    $nrOcorrenciaCalc = $this->hcmParameters->getNrOcorrenciaCalculo();

                    if($nrOcorrenciaCalc > 1 && !strstr($idRefeValorCalc, '_RECALCULO')){
                        $idRefeValorCalc .= '_RECALCULO';
                    }
                    
                    $obj->setNrcalculofolha($row['NRCALCULOFOLHA']);
                    $obj->setNrvinculom($row['NRVINCULOM']);
                    $obj->setNreventom($row['NREVENTOM']);
                    $obj->setVrreffolha($row['VRREFFOLHA']);
                    $obj->setVreventofolha($row['VREVENTOFOLHA']);
                    $obj->setIdevendemoncalc($idevendemoncalc);
                    $obj->setDtocorrencia(DateUtil::getDataDeString(substr($row['DTOCORRENCIA'], 0, 10)));
                    $obj->setQtocorproxperi($row['QTOCORPROXPERI']);
                    $obj->setIdrefevalorcalc($idRefeValorCalc);
                    $obj->setVrvelho($row['VRVELHO']);
                    $obj->setNrlotelancevento($row['NRLOTELANCEVENTO']);
                    $obj->setNrorg($row['NRORG']);
                    $obj->setCdoperultatu($this->hcmParameters->getCdoperador());
                    $obj->setDtultatu(DateUtil::getDataAtual());
                    $obj->setNrorgultatu($this->hcmParameters->getNrorgTrabalho());
                    
                    if(!$row['CDOPERINCLUSAO'] && !$row['NRORGINCLUSAO'] && !$row['DTINCLUSAO']){
                        $obj->setCdoperinclusao($this->hcmParameters->getCdoperador());
                        $obj->setDtinclusao(DateUtil::getDataAtual());
                        $obj->setNrorginclusao($this->hcmParameters->getNrorgTrabalho());
                    }
                    
                    $this->entityManager->persist($obj);
                    $this->entityManager->flush($obj);
                
                    $message = new \Zeedhi\Framework\DTO\Response\Message('Item(ns) salvo(s) com sucesso!', \Zeedhi\Framework\DTO\Response\Message::TYPE_MESSAGE);
                    if($message instanceof \Zeedhi\Framework\DTO\Response\Message){
                        $response->addMessage($message);
                    }
                    
                }else{
                    //$this->deleteItemCalculoFolha([$row]);
                    
                    $message = new \Zeedhi\Framework\DTO\Response\Message('Item(ns) salvo(s) com sucesso!', \Zeedhi\Framework\DTO\Response\Message::TYPE_MESSAGE);
                    if($message instanceof \Zeedhi\Framework\DTO\Response\Message){
                        $response->addMessage($message);
                    }
                }
            } 
            $this->entityManager->commit();
        }catch(\Exception $e){
            $this->entityManager->rollback();
            throw $e;
        }
    }
    
    
}