<?php

namespace HCM\Geral\Logic\Apolo;

use HCM\Util\DateUtil;
use HCM\Util\FPA;

class PreparacaoApolo extends \Zeedhi\Queue\Producer {

    //apollo port browser = 61680
    const LIMIT_LOTE_FOUR = 4;
    const LIMIT_LOTE_ONE = 1;
    
    const PROCESS_ = 12;
    const PROCESS_CONTABILIZACAO = 12;
    
    private $return;
    private $horaDisparo;

    protected static $queueName = "/queue/";

    public function __construct($nrorg, $url, $port, $user, $password, $broke, $process=null){
        
        $queueConnection = new \Zeedhi\Queue\Connection($url, $port, $user, $password, $broke);
        parent::__construct($queueConnection);
        
        $this->_nrOrgTrabalho = $nrorg;
        $this->process = $process;
        
        $this->return = array();
    }
    
    private function getUrlJenkinsCalculoConsumer($hora) {
        $nrorgHora = $this->_nrOrgTrabalho.$hora;
        return 'https://ci-pebbian.teknisa.cloud/job/Pebbian%20-%20hcmCalculoConsumer/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }

    private function getUrlJenkinsOneConsumer($hora) {
        $nrorgHora = $this->_nrOrgTrabalho.$hora;
        return 'https://ci-pebbian.teknisa.cloud/job/Pebbian%20-%20HcmOneConsumer/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }
    
    //PHP 5
    /*private function getUrlJenkinsMobileCalculoConsumer($hora) {
        $nrorgHora = $this->_nrOrgTrabalho.$hora;
        return 'https://ci-pebbian.teknisa.cloud/job/Pebbian%20-%20MobileHcmCalculoConsumer/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }
    
    private function getUrlJenkinsMobileOneConsumer($hora) {
        $nrorgHora = $this->_nrOrgTrabalho.$hora;
        return 'https://ci-pebbian.teknisa.cloud/job//Pebbian%20-%20MobileHcmOneConsumer/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }*/
    
    private function getUrlJenkinsMobileCalculoConsumer($hora) {
        $nrorgHora = $this->_nrOrgTrabalho.$hora;
        return 'https://ci-pebbian.teknisa.cloud/job/Pebbian%20-%20MobileHcmCalculoConsumer%20Novo%20PHP7/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }
    
    private function getUrlJenkinsMobileOneConsumer($hora) {
        $nrorgHora = $this->_nrOrgTrabalho.$hora;
        return 'https://ci-pebbian.teknisa.cloud/job/Pebbian%20-%20MobileHcmOneConsumer%20Novo%20PHP7/buildWithParameters?token=113793acda4915826730990bdca76e230a&NRORG='.$nrorgHora;
    }

    public function sendMessage($queueName, $params)
    {
        $dtatual = DateUtil::getDataAtual();
        $horaDisparo = $dtatual->format('H:i:s');
        $this->horaDisparo = str_replace(':','',$horaDisparo);
        
        self::$queueName .= 'hcm_'.$queueName.'_'.$this->_nrOrgTrabalho.$this->horaDisparo;

        $count = 0;
        $registros = array();

        $qtRegistros = count($params["REGISTROS"]);
        
        if($this->process === self::PROCESS_CONTABILIZACAO || $qtRegistros < 16){
            $limiteLote = $qtRegistros / self::LIMIT_LOTE_ONE;
            $url = $this->getUrlJenkinsMobileOneConsumer($this->horaDisparo);
        }else{
            $limiteLote = $qtRegistros / self::LIMIT_LOTE_FOUR;
            $url = $this->getUrlJenkinsMobileCalculoConsumer($this->horaDisparo);
        }
        
        //Inicializa Consumidores e aguarda 20 segundos para os mesmos estarem em execução.
        $this->inicializaConsumidorJenkins($url);
        sleep(20);

        if ($qtRegistros > $limiteLote) {
            foreach ($params["REGISTROS"] as $key => $registro) {
                if ($count < $limiteLote) {
                    $registros[$key] = $registro;
                    $count++;
                } else {
                    $params["REGISTROS"] = $registros;
                    $message = json_encode(
                        array(
                            'PARAMS' => array(
                                $params
                            )
                        )
                    );

                    $this->send($message);
                    $registros = array();
                    $registros[$key] = $registro; // o registro que faz entrar no 'else' não é contemplado no array, então zeramos adicionando ele para o próximo
                    $count = 1; // como adicionamos o registro acima, o contador deve iniciar com zero.
                }
            }
        } else {
            $registros = $params["REGISTROS"];
        }

        if (count($registros) > 0) {
            $params["REGISTROS"] = $registros;
            $message = json_encode(
                array(
                    'PARAMS' => array(
                        $params
                    )
                )
            );
            $this->send($message);
        }
        
        $this->return['MSG'] = 'Atenção! Através desta opção, o processo de gravação será realizado em segundo plano. Em breve, a notificação de finalização do processo chegará em seu e-mail.';
        return $this->return;
    }

    private function inicializaConsumidorJenkins($url) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL,$url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
        curl_exec($ch);
        
        $requestInfo = curl_getinfo($ch);
        
        if ($requestInfo['http_code'] !== 201) {
            throw new \Exception('Não foi possível inicializar o consumidor via Jenkis, favor verificar, código: '.$requestInfo['http_code']);
        }
    }
    
}
