<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use HCM\Util\Repositories;

class AlteEstabilidadeRepository {

    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }

    public function retornaEstabilidadePorPeriodo($nrorg, $nrvinculom, $dtiniperiodo, $dtfimperiodo, $nraltestabvinc = null) {
        $gpeAlteestabvinc = Repositories::GPE_ALTESTABVINC;
        $sql = <<<SQL
SELECT a
  FROM $gpeAlteestabvinc a
 WHERE a.nrorg         = :NRORG
   AND a.nrvinculom    = :NRVINCULOM
   AND ((a.dtiniestabvinc BETWEEN '$dtiniperiodo' AND '$dtfimperiodo')
        OR
        (a.dtfimestabvinc BETWEEN '$dtiniperiodo' AND '$dtfimperiodo'))
   AND (a.nraltestabvinc  <> :NRALTESTABVINC or :NRALTESTABVINC IS NULL)
SQL;
        $params = array(
            'NRORG' => $nrorg,
            'NRVINCULOM' => $nrvinculom,
            'NRALTESTABVINC' => $nraltestabvinc
        );
        $result = $this->entityManager->createQuery($sql)->execute($params);
        return $result;
    }

} 
